#pragma once

#ifndef __INIOBJ_H_
#define __INIOBJ_H_

#include "resource.h"
#include "IniUtil_i.h" //NOLINT(modernize-use-using)


class ATL_NO_VTABLE CIniObj :
  public ATL::CComObjectRootEx<ATL::CComSingleThreadModel>,
  public ATL::CComCoClass<CIniObj, &CLSID_IniUtil>,
  public ATL::ISupportErrorInfoImpl<&IID_IIniUtil>,
  public ATL::IDispatchImpl<IIniUtil, &IID_IIniUtil, &LIBID_INIUTILLib>
{
public:
  CIniObj() = default;
  CIniObj(const CIniObj&) = delete;
  CIniObj(CIniObj&&) = delete;
  virtual ~CIniObj() = default;

  CIniObj& operator=(const CIniObj&) = delete;
  CIniObj& operator=(CIniObj&&) = delete;

#pragma warning(suppress: 26440)
DECLARE_REGISTRY_RESOURCEID(IDR_INIOBJ)
DECLARE_NOT_AGGREGATABLE(CIniObj)

#pragma warning(suppress: 26434)
DECLARE_PROTECT_FINAL_CONSTRUCT()

#pragma warning(suppress: 26429 26440 26477 26481)
BEGIN_COM_MAP(CIniObj) //NOLINT(modernize-avoid-c-arrays, modernize-use-noexcept)
  COM_INTERFACE_ENTRY(IIniUtil)
  COM_INTERFACE_ENTRY(IDispatch)
  COM_INTERFACE_ENTRY(ISupportErrorInfo)
#pragma warning(suppress: 26477 26485)
END_COM_MAP() //NOLINT(modernize-avoid-c-arrays)

//IIniUtil
  STDMETHOD(get_Filename)(BSTR* pbstrFilename);
  STDMETHOD(put_Filename)(BSTR bstrFilename);
  STDMETHOD(get_Sections)(VARIANT* pvSections);
  STDMETHOD(WriteString)(BSTR bstrSection, BSTR bstrKey, BSTR bstrValue);
  STDMETHOD(WriteInteger)(BSTR bstrSection, BSTR bstrKey, int nValue);
  STDMETHOD(WriteVariant)(BSTR bstrSection, BSTR bstrKey, VARIANT vValue);
  STDMETHOD(WriteSection)(BSTR bstrSection, VARIANT vKeyValues);
  STDMETHOD(ReadString)(BSTR bstrSection, BSTR bstrKey, BSTR bstrDefaultValue, BSTR* pbstrValue);
  STDMETHOD(ReadInteger)(BSTR bstrSection, BSTR bstrKey, int nDefaultValue, int* pnValue);
  STDMETHOD(ReadVariant)(BSTR bstrSection, BSTR bstrKey, VARIANT* pvValue);
  STDMETHOD(ReadSection)(BSTR bstrSection, VARIANT* pvKeyValues);
  STDMETHOD(ReadKeys)(BSTR bstrSection, VARIANT* pvKeys);
  STDMETHOD(DeleteSection)(BSTR bstrSection);
  STDMETHOD(DeleteKey)(BSTR bstrSection, BSTR bstrKey);

protected:
//Misc methods
  HRESULT MakeSafeArrayVariantFromMultiSZString(_In_z_ LPCWSTR pszString, _Out_ VARIANT* pvVariant);

//Member variables
  ATL::CComBSTR m_sFilename;
};

#pragma warning(suppress: 26477)
OBJECT_ENTRY_AUTO(__uuidof(IniUtil), CIniObj)


#endif //#ifndef __INIOBJ_H_
