#include "StdAfx.h"
#include "resource.h"
#include "IniUtil_i.c"
#include "dllmain.h"


__control_entrypoint(DllExport)
STDAPI DllCanUnloadNow()
{
  return _AtlModule.DllCanUnloadNow();
}

_Check_return_ STDAPI  DllGetClassObject(_In_ REFCLSID rclsid, _In_ REFIID riid, _Outptr_ LPVOID FAR* ppv)
{
  return _AtlModule.DllGetClassObject(rclsid, riid, ppv);
}

__control_entrypoint(DllExport)
STDAPI DllRegisterServer()
{
  return _AtlModule.DllRegisterServer();
}

__control_entrypoint(DllExport)
STDAPI DllUnregisterServer()
{
  return _AtlModule.DllUnregisterServer();
}

STDAPI DllInstall(BOOL bInstall, _In_opt_ LPCWSTR pszCmdLine)
{
  HRESULT hr{E_FAIL};
  static const wchar_t* szUserSwitch{L"user"};

  if (pszCmdLine != nullptr) //NOLINT(clang-analyzer-optin.cplusplus.VirtualCall)
  {
    if (_wcsnicmp(pszCmdLine, szUserSwitch, wcslen(szUserSwitch)) == 0)
      ATL::AtlSetPerUserRegistration(true);
  }

  if (bInstall) //NOLINT(clang-analyzer-optin.cplusplus.VirtualCall)
  {
    hr = DllRegisterServer();
    if (FAILED(hr))
      DllUnregisterServer();
  }
  else
    hr = DllUnregisterServer(); //NOLINT(clang-analyzer-optin.cplusplus.VirtualCall)

  return hr;
}
